var config;
var designer;
var jsonarray;
var workbook;
window.onload = function () {



      GC.Spread.Common.CultureManager.culture("zh-cn");

      designer = new GC.Spread.Sheets.Designer.Designer(document.getElementById("gc-designer-container"), GC.Spread.Sheets.Designer.ToolBarModeConfig);
      config = GC.Spread.Sheets.Designer.ToolBarModeConfig;
      designer.setData("custompapersize", {
            width: 50,
            height: 50
      })
      adddlg(config);
      designer.setConfig(config);
      designer.refresh();


      var spread = new GC.Spread.Sheets.Workbook();
      spread = designer.getWorkbook();
      spread.commandManager().addListener('', function (args) {
            var command = args.command;
            if (command.cmd == "Designer.setPageLayout" && command.paperKind == 0) {
                  var custompapersize = designer.getData("custompapersize");
                  spread.getActiveSheet().printInfo().paperSize(new GC.Spread.Sheets.Print.PaperSize(custompapersize.width, custompapersize.height));
            }
      });

      var sheet = spread.getActiveSheet();


}
var CustomPaperSizeTemplate = {
      templateName: "CustomPaperSizeTemplate",
      title: "设置自定义纸张尺寸",
      width: 300,
      height: 200,
      content: [{
            type: "FlexContainer",
            children: [{
                        type: "TextBlock",
                        text: "设置纸张自定义宽高",
                        margin: "5px 10px"
                  },
                  {
                        type: "Column",
                        width: "auto",
                        children: [{
                                    type: "ColumnSet",
                                    children: [{
                                                "type": "Column",
                                                "width": "50px",
                                                "children": [{
                                                      "type": "TextBlock",
                                                      "margin": "5px 10px -5px 10px",
                                                      "text": "宽:"
                                                }]
                                          },
                                          {
                                                "type": "Column",
                                                "width": "auto",
                                                "children": [{
                                                      type: "NumberEditor",
                                                      bindingPath: "width",
                                                      margin: "5px 10px"
                                                }]
                                          }
                                    ]
                              },
                              {
                                    type: "ColumnSet",
                                    width: "160px",
                                    children: [{
                                                "type": "Column",
                                                "width": "50px",
                                                "children": [{
                                                      "type": "TextBlock",
                                                      "margin": "5px 10px",
                                                      "text": "高:"
                                                }]
                                          },
                                          {
                                                "type": "Column",
                                                "width": "auto",
                                                "children": [{
                                                      type: "NumberEditor",
                                                      bindingPath: "height",
                                                      margin: "5px 10px"
                                                }]
                                          }
                                    ]
                              },
                        ]
                  },
            ]
      }]
};

function adddlg(config) {
      config.commandMap = {};
      GC.Spread.Sheets.Designer.registerTemplate("CustomPaperSize", CustomPaperSizeTemplate);
      var config = GC.Spread.Sheets.Designer.ToolBarModeConfig;
      config.commandMap["cmdPaperSizeDialog"] = paperSizeDialog;

      var command = {
            text: "纸张尺寸",
            id: "time",
            buttonGroups: [{
                  commandGroup: {
                        "children": [
                              "cmdPaperSizeDialog"
                        ]

                  }
            }]
      };
      config.ribbon.panels[2].buttonGroups[0].commandGroup.children.splice(4, 0, "cmdPaperSizeDialog");
}


var paperSizeDialog = {
      title: "自定义纸张尺寸",
      text: "自定义纸张尺寸",
      "direction": "horizontal",
      commandName: "cmdPaperSizeDialog",
      iconClass: "ribbon-button-pageSetup-size",
      bigButton: true,
      type: 'button', // 单击按钮命令时，将调用执行函数。
      execute: (context, propertyName) => {
            var custompapersize = designer.getData("custompapersize")
            GC.Spread.Sheets.Designer.showDialog("CustomPaperSize", {
                  width: custompapersize.width,
                  height: custompapersize.height
            }, (result) => {
                  console.log(result);

                  let {
                        width,
                        height
                  } = result; // 结果的数据结构.
                  designer.setData("custompapersize", {
                        width: width,
                        height: height
                  })
                  let spread = context.getWorkbook();
                  let sheet = spread.getActiveSheet();
                  sheet.printInfo().paperSize(new GC.Spread.Sheets.Print.PaperSize(width, height));
            }, (e) => { // 错误回调
                  console.log(e);
            }, (result) => { // 有效回调，用于检查结果值是否有效。如果没有，对话框将无法关闭。
                  return result;
            });
      }
}